var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { mapperProperty, deepMapperProperty, filterMapperProperty, deserializeArr, deserialize, mock, serializeArr, serialize } from '../src/index';
import { getRandomInt, getRandomString, getRandomFloat, formatDate } from '../src/lib/utils';
var Lesson = (function () {
    function Lesson() {
        this.name = '';
        this.teacher = '';
        this.datetime = '';
        this.date = '';
        this.time = '';
        this.compulsory = false;
    }
    __decorate([
        mapperProperty('ClassName', 'string'),
        __metadata("design:type", String)
    ], Lesson.prototype, "name", void 0);
    __decorate([
        mapperProperty('Teacher', 'string'),
        __metadata("design:type", String)
    ], Lesson.prototype, "teacher", void 0);
    __decorate([
        mapperProperty('DateTime', 'datetime'),
        __metadata("design:type", String)
    ], Lesson.prototype, "datetime", void 0);
    __decorate([
        mapperProperty('Date', 'date'),
        __metadata("design:type", String)
    ], Lesson.prototype, "date", void 0);
    __decorate([
        mapperProperty('Time', 'time'),
        __metadata("design:type", String)
    ], Lesson.prototype, "time", void 0);
    __decorate([
        mapperProperty('Compulsory', 'boolean'),
        __metadata("design:type", Boolean)
    ], Lesson.prototype, "compulsory", void 0);
    return Lesson;
}());
var Address = (function () {
    function Address() {
        this.province = '';
        this.city = '';
        this.fullAddress = '';
    }
    __decorate([
        mapperProperty('province', 'string'),
        __metadata("design:type", String)
    ], Address.prototype, "province", void 0);
    __decorate([
        mapperProperty('city', 'string'),
        __metadata("design:type", String)
    ], Address.prototype, "city", void 0);
    __decorate([
        mapperProperty('full_address', 'string'),
        __metadata("design:type", String)
    ], Address.prototype, "fullAddress", void 0);
    return Address;
}());
var Student = (function () {
    function Student() {
        this.id = '';
        this.name = '';
        this.age = 0;
        this.notNum = 0;
        this.notFloat = 0;
        this.unknownType = '';
        this.grade = 0;
        this.addressIds = [];
        this.address = null;
        this.lessons = [];
        this.status = '';
        this.extra = '';
    }
    __decorate([
        mapperProperty('StudentID', 'string'),
        __metadata("design:type", String)
    ], Student.prototype, "id", void 0);
    __decorate([
        mapperProperty('StudentName', 'string'),
        __metadata("design:type", String)
    ], Student.prototype, "name", void 0);
    __decorate([
        mapperProperty('StudentAge', 'int'),
        __metadata("design:type", Number)
    ], Student.prototype, "age", void 0);
    __decorate([
        mapperProperty('NotFloat', 'float'),
        __metadata("design:type", Number)
    ], Student.prototype, "notFloat", void 0);
    __decorate([
        mapperProperty('NotANum', 'int'),
        __metadata("design:type", Number)
    ], Student.prototype, "notNum", void 0);
    __decorate([
        mapperProperty('UnknownType', 'String'),
        __metadata("design:type", String)
    ], Student.prototype, "unknownType", void 0);
    __decorate([
        mapperProperty('Grade', 'float'),
        __metadata("design:type", Number)
    ], Student.prototype, "grade", void 0);
    __decorate([
        mapperProperty('AddressIds', 'string'),
        __metadata("design:type", Array)
    ], Student.prototype, "addressIds", void 0);
    __decorate([
        deepMapperProperty('Address', Address),
        __metadata("design:type", Address)
    ], Student.prototype, "address", void 0);
    __decorate([
        deepMapperProperty('Lessons', Lesson),
        __metadata("design:type", Array)
    ], Student.prototype, "lessons", void 0);
    __decorate([
        filterMapperProperty('State', function (val) {
            if (val === void 0) { val = 0; }
            var map = { '0': '未知', '1': '读书中', '2': '辍学', '3': '毕业' };
            return map["" + val];
        }),
        __metadata("design:type", String)
    ], Student.prototype, "status", void 0);
    return Student;
}());
var Students = [
    {
        StudentID: '123456',
        StudentName: '李子明',
        StudentAge: '10',
        NotANum: 'lol',
        NotFloat: 'def',
        UnknownType: 'funny',
        Grade: '98.6',
        AddressIds: [1, 2],
        Address: {
            province: '广东',
            city: '深圳',
            full_address: 'xxx小学三年二班'
        },
        Lessons: [
            {
                ClassName: '中国上下五千年',
                Teacher: '建国老师',
                DateTime: 1609430399000,
                Date: 1609430399000,
                Time: 1609430399000,
                Compulsory: 1
            },
            {
                ClassName: '古筝的魅力',
                Teacher: '美丽老师',
                DateTime: ''
            }
        ],
        State: 1,
        extra: '额外信息'
    },
    {
        StudentID: '888888',
        StudentName: '丁仪',
        StudentAge: '18',
        Grade: null,
        Address: {
            province: '浙江',
            city: '杭州',
            full_address: 'xxx中学高三二班'
        },
        Lessons: [],
        State: 2
    }
];
var _a = deserializeArr(Student, Students), first = _a[0], second = _a[1];
delete second.notFloat;
var oriFirst = serializeArr(Student, [first, second])[0];
var mockData1 = mock(Student, { fieldLength: { age: 20, grade: 4, name: 6 } });
var mockData2 = mock(Student, { fieldLength: { age: 20, grade: 4, name: 6 }, arrayFields: ['lessons'] });
describe('transformer', function () {
    test('name', function () {
        expect(first.id).toBe('123456');
    });
    test('type', function () {
        expect(second.age).toBe(18);
        expect(first.grade).toBeCloseTo(98.6);
        expect(second.grade).toBeNull();
    });
    test('sample', function () {
        var _a = first.addressIds, addressIds = _a === void 0 ? [] : _a;
        var target = addressIds[0];
        expect(typeof target).toBe('string');
    });
    test('deep', function () {
        var _a = first.address, address = _a === void 0 ? { city: '' } : _a;
        expect(address.city).toBe('深圳');
    });
    test('deep arr', function () {
        var _a = first.lessons, lessons = _a === void 0 ? [] : _a;
        var target = lessons[0];
        expect(target.name).toBe('中国上下五千年');
    });
});
describe('filter', function () {
    test('inner', function () {
        var target = (first.lessons || [])[0];
        var times = 1609430399000;
        var datetime = formatDate(times);
        var date = formatDate(times, 'Y-M-D');
        var time = formatDate(times, 'h:m:s');
        expect(target.datetime).toBe(datetime);
        expect(target.date).toBe(date);
        expect(target.time).toBe(time);
    });
    test('custom', function () {
        expect(second.status).toBe('辍学');
    });
});
describe('boundary', function () {
    test('do nothing', function () {
        expect(first.extra).toBe('额外信息');
    });
    test('deserialize first parameter illegal input', function () {
        var flag = 0;
        try {
            deserialize(null, {});
            flag = 1;
        }
        catch (err) {
            expect(err.message).toBe('[type-json-mapper/deserialize]: missing Clazz or json');
            flag = 2;
        }
        expect(flag).toBe(2);
    });
    test('deserialize second parameter illegal input', function () {
        var flag = 0;
        try {
            deserialize(Student, []);
            flag = 1;
        }
        catch (err) {
            expect(err.message).toBe('[type-json-mapper/deserialize]: json is not a object');
            flag = 2;
        }
        expect(flag).toBe(2);
    });
    test('deserializeArr illegal input', function () {
        var flag = 0;
        try {
            deserializeArr(null, []);
            flag = 1;
        }
        catch (err) {
            expect(err.message).toBe('[type-json-mapper/deserializeArr]: missing Clazz or list');
            flag = 2;
        }
        expect(flag).toBe(2);
    });
    test('serialize first parameter illegal input', function () {
        var flag = 0;
        try {
            serialize(null, {});
            flag = 1;
        }
        catch (err) {
            expect(err.message).toBe('[type-json-mapper/serialize]: missing Clazz or json');
            flag = 2;
        }
        expect(flag).toBe(2);
    });
    test('serialize second parameter illegal input', function () {
        var flag = 0;
        try {
            serialize(Student, []);
            flag = 1;
        }
        catch (err) {
            expect(err.message).toBe('[type-json-mapper/serialize]: json is not a object');
            flag = 2;
        }
        expect(flag).toBe(2);
    });
    test('serializeArr illegal input', function () {
        var flag = 0;
        try {
            serializeArr(null, []);
            flag = 1;
        }
        catch (err) {
            expect(err.message).toBe('[type-json-mapper/serializeArr]: missing Clazz or list');
            flag = 2;
        }
        expect(flag).toBe(2);
    });
    test('mock first parameter illegal input', function () {
        var flag = 0;
        try {
            mock(null);
            flag = 1;
        }
        catch (err) {
            expect(err.message).toBe('[type-json-mapper/mock]: missing Clazz');
            flag = 2;
        }
        expect(flag).toBe(2);
    });
    test('mock second parameter illegal input', function () {
        var flag = 0;
        try {
            mock(Student, null);
            flag = 1;
        }
        catch (err) {
            flag = 2;
        }
        expect(flag).toBe(1);
    });
});
describe('serialize', function () {
    test('deep', function () {
        var _a = oriFirst.Lessons, Lessons = _a === void 0 ? [] : _a;
        var target = Lessons[0];
        var ClassName = (target || {}).ClassName;
        expect(ClassName).toBe('中国上下五千年');
    });
    test('array', function () {
        var _a = oriFirst.AddressIds, AddressIds = _a === void 0 ? [] : _a;
        var target = AddressIds[0];
        expect(target).toBe('1');
    });
});
describe('mock', function () {
    test('generate', function () {
        expect(mockData1.name.length).toBe(6);
    });
    test('generate arr', function () {
        expect(Object.prototype.toString.call(mockData1.lessons)).toBe('[object Object]');
        expect(Object.prototype.toString.call(mockData2.lessons)).toBe('[object Array]');
    });
});
describe('tools', function () {
    test('illegal parameters', function () {
        var num = getRandomInt();
        expect(num).toBe(0);
        var string = getRandomString();
        expect(string).toBe('');
        var float = getRandomFloat();
        expect(float).toBe(0);
    });
});
